/********************************/
/* Author: florian letombe*/
/* File: Font.cpp*/
/* Date: Lundi 13 Novembre */
/********************************/

#include "Font.h"

Font::Font(char * type, int taille, SDL_Color couleur) {
  //Initialisation de SDL_ttf
  if( TTF_Init() == -1 ) {
    cerr << "Erreur dans l'initialisation de la font:" << TTF_GetError();
    exit (0);
  }

  font = TTF_OpenFont( type, taille );

  //Si il y a une erreur au chargement du font
  if( font == NULL ){
    cerr << "Erreur dans le chargement de la font:" << TTF_GetError();
    exit (0);
  }

  textColor = couleur;

  message = NULL;
}

Font::~Font() {
  SDL_FreeSurface( message );

  //On ferme le font qu'on a utilise
  TTF_CloseFont( font );
}

SDL_Surface * Font::GetMessage (char * texte) {
  //application du texte
  message = TTF_RenderText_Solid( font, texte, textColor );

  //Si il y a une erreur lors de l'application du texte
  if( message == NULL ) {
    cerr << "Erreur dans l'initialisation du message:" << TTF_GetError();
    exit (0);
  }

  return message;
}
