/********************************/
/* Author: florian letombe*/
/* File: Image.cpp*/
/* Date: Lundi 13 Novembre */
/********************************/

using namespace std;

#include <iostream>
#include "Image.h"

SDL_Surface *Image::Load( char* filename ){
  //L'image qui est chargee
  SDL_Surface* loadedImage = NULL;

  //L'image optimisee que nous utiliserons par la suite
  SDL_Surface* optimizedImage = NULL;

  //Chargement de l'image
  loadedImage = IMG_Load( filename );

  //Si l'image est chargee correctement
  if( loadedImage != NULL ) {
    //creation de l'image optimisee
    optimizedImage = SDL_DisplayFormat( loadedImage );

    //liberation de l'ancienne image
    SDL_FreeSurface( loadedImage );

    //si l'image optimisee cree est bonne
    if( optimizedImage != NULL ) {
      //transparence
      SDL_SetColorKey( optimizedImage, SDL_RLEACCEL | SDL_SRCCOLORKEY,
		       SDL_MapRGB( optimizedImage->format, 255, 255, 255 ) );
    }
  }

  //on retourne l'image optimisee
  return optimizedImage;
}

Image::Image(char* filename, int largeur, int hauteur, int nb_couleurs) {
  image = SDL_SetVideoMode(largeur,hauteur,nb_couleurs,SDL_HWSURFACE) ;

  if (image == NULL) {
    cerr << "Erreur dans l'initialisation des modes vidos:" << SDL_GetError();
    SDL_Quit();
  }

  image = Load(filename);
}

Image::~Image() {
  SDL_FreeSurface( image );
}
